searchNodes=[{"doc":"Templates are markup languages that are compiled to Elixir code. This module provides functions for loading and compiling templates from disk. A markup language is compiled to Elixir code via an engine. See Phoenix.Template.Engine . In practice, developers rarely use Phoenix.Template directly. Instead, libraries such as Phoenix.View and Phoenix.LiveView use it as a building block. Custom Template Engines Phoenix supports custom template engines. Engines tell Phoenix how to convert a template path into quoted expressions. See Phoenix.Template.Engine for more information on the API required to be implemented by custom engines. Once a template engine is defined, you can tell Phoenix about it via the template engines option: config :phoenix , :template_engines , eex : Phoenix.Template.EExEngine , exs : Phoenix.Template.ExsEngine Format encoders Besides template engines, Phoenix has the concept of format encoders. Format encoders work per format and are responsible for encoding a given format to a string. For example, when rendering JSON, your templates may return a regular Elixir map. Then the JSON format encoder is invoked to convert it to JSON. A format encoder must export a function called encode_to_iodata!/1 which receives the rendering artifact and returns iodata. New encoders can be added via the format encoder option: config :phoenix_template , :format_encoders , html : Phoenix.HTML.Engine","ref":"Phoenix.Template.html","title":"Phoenix.Template","type":"module"},{"doc":"","ref":"Phoenix.Template.html#compile_all/4","title":"Phoenix.Template.compile_all/4","type":"macro"},{"doc":"Returns a keyword list with all template engines extensions followed by their modules.","ref":"Phoenix.Template.html#engines/0","title":"Phoenix.Template.engines/0","type":"function"},{"doc":"Returns all template paths in a given template root.","ref":"Phoenix.Template.html#find_all/3","title":"Phoenix.Template.find_all/3","type":"function"},{"doc":"Returns the format encoder for the given template.","ref":"Phoenix.Template.html#format_encoder/1","title":"Phoenix.Template.format_encoder/1","type":"function"},{"doc":"Returns the hash of all template paths in the given root. Used by Phoenix to check if a given root path requires recompilation.","ref":"Phoenix.Template.html#hash/3","title":"Phoenix.Template.hash/3","type":"function"},{"doc":"","ref":"Phoenix.Template.html#module_to_template_root/3","title":"Phoenix.Template.module_to_template_root/3","type":"function"},{"doc":"","ref":"Phoenix.Template.html#template_path_to_name/2","title":"Phoenix.Template.template_path_to_name/2","type":"function"},{"doc":"","ref":"Phoenix.Template.html#t:path/0","title":"Phoenix.Template.path/0","type":"type"},{"doc":"","ref":"Phoenix.Template.html#t:root/0","title":"Phoenix.Template.root/0","type":"type"},{"doc":"The Phoenix engine that handles the .eex extension.","ref":"Phoenix.Template.EExEngine.html","title":"Phoenix.Template.EExEngine","type":"module"},{"doc":"Callback implementation for Phoenix.Template.Engine.compile/2 .","ref":"Phoenix.Template.EExEngine.html#compile/2","title":"Phoenix.Template.EExEngine.compile/2","type":"function"},{"doc":"Specifies the API for adding custom template engines into Phoenix. Engines must implement the compile/2 function, that receives the template file and the template name and outputs the template quoted expression: def compile ( template_path , template_name ) See Phoenix.Template.EExEngine for an example engine implementation.","ref":"Phoenix.Template.Engine.html","title":"Phoenix.Template.Engine","type":"behaviour"},{"doc":"","ref":"Phoenix.Template.Engine.html#c:compile/2","title":"Phoenix.Template.Engine.compile/2","type":"callback"},{"doc":"The Phoenix engine that handles the .exs extension.","ref":"Phoenix.Template.ExsEngine.html","title":"Phoenix.Template.ExsEngine","type":"module"},{"doc":"Callback implementation for Phoenix.Template.Engine.compile/2 .","ref":"Phoenix.Template.ExsEngine.html#compile/2","title":"Phoenix.Template.ExsEngine.compile/2","type":"function"},{"doc":"","ref":"changelog.html","title":"CHANGELOG","type":"extras"},{"doc":"Initial release","ref":"changelog.html#1-0-0","title":"CHANGELOG - 1.0.0","type":"extras"}]